Hi,

We're working on a rather large change to how we do context switching
in the kernel and the diff is getting almost ready to get into the
tree. I'd like to have some wider testing on this since it's a quite
a bit of brain surgery on all architectures.

Right now only arm is missing from the diff, so if you have arm machines
you can't test, everyone else should be able to run this. This is
of course -current we're talking about.

What needs to be tested is primarily that everything works and nothing
crashes, but also I'd like people to watch for weird scheduler behavior.
Music not playing, X being slow, top showing weird numbers, stuff like
that.

Please mail me positive test results privately and cc the list if
something loks wrong.

//art

Index: arch/alpha/alpha/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/alpha/alpha/genassym.cf,v
retrieving revision 1.10
diff -u -r1.10 genassym.cf
--- arch/alpha/alpha/genassym.cf	28 May 2007 23:10:10 -0000	1.10
+++ arch/alpha/alpha/genassym.cf	25 Sep 2007 09:53:36 -0000
@@ -103,17 +103,12 @@
 
 # Important offsets into the proc struct & associated constants
 struct	proc
-member	p_forw
-member	p_back
 member	p_addr
 member	p_vmspace
 member	p_stat
 member	P_MD_FLAGS	p_md.md_flags
 member	P_MD_PCBPADDR	p_md.md_pcbpaddr
 member	p_cpu
-struct	prochd
-member	ph_link
-member	ph_rlink
 
 export	SONPROC
 
Index: arch/alpha/alpha/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/alpha/alpha/locore.s,v
retrieving revision 1.30
diff -u -r1.30 locore.s
--- arch/alpha/alpha/locore.s	28 May 2007 23:10:10 -0000	1.30
+++ arch/alpha/alpha/locore.s	25 Sep 2007 09:53:37 -0000
@@ -716,123 +716,38 @@
 
 /**************************************************************************/
 
-IMPORT(whichqs, 4)
-
-/*
- * When no processes are on the runq, cpu_switch branches to idle
- * to wait for something to come ready.
- * Note: this is really a part of cpu_switch() but defined here for kernel
- * profiling.
- */
-LEAF(idle, 0)
-	br	pv, 1f
-1:	LDGP(pv)
-	/* Note: GET_CURPROC clobbers v0, t0, t8...t11. */
-	GET_CURPROC
-	stq	zero, 0(v0)			/* curproc <- NULL for stats */
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	CALL(sched_unlock_idle)			/* release sched_lock */
-#endif
-	mov	zero, a0			/* enable all interrupts */
-	call_pal PAL_OSF1_swpipl
-2:	ldl	t0, whichqs			/* look for non-empty queue */
-	beq	t0, 2b
-	ldiq	a0, ALPHA_PSL_IPL_HIGH		/* disable all interrupts */
-	call_pal PAL_OSF1_swpipl
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	CALL(sched_lock_idle)			/* acquire sched_lock */
-#endif
-	jmp	zero, cpu_switch_queuescan	/* jump back into the fire */
-	END(idle)
-
 /*
- * cpu_switch()
- * Find the highest priority process and resume it.
+ * cpu_switchto(struct proc *old, struct proc *new)
+ * Switch from "old" proc to "new".
  */
-LEAF(cpu_switch, 0)
+LEAF(cpu_switchto, 2)
 	LDGP(pv)
-	/*
-	 * do an inline savectx(), to save old context
-	 * Note: GET_CURPROC clobbers v0, t0, t8...t11.
-	 */
-	GET_CURPROC
-	ldq	a0, 0(v0)
-	ldq	a1, P_ADDR(a0)
-	/* NOTE: ksp is stored by the swpctx */
-	stq	s0, U_PCB_CONTEXT+(0 * 8)(a1)	/* store s0 - s6 */
-	stq	s1, U_PCB_CONTEXT+(1 * 8)(a1)
-	stq	s2, U_PCB_CONTEXT+(2 * 8)(a1)
-	stq	s3, U_PCB_CONTEXT+(3 * 8)(a1)
-	stq	s4, U_PCB_CONTEXT+(4 * 8)(a1)
-	stq	s5, U_PCB_CONTEXT+(5 * 8)(a1)
-	stq	s6, U_PCB_CONTEXT+(6 * 8)(a1)
-	stq	ra, U_PCB_CONTEXT+(7 * 8)(a1)	/* store ra */
-	call_pal PAL_OSF1_rdps			/* NOTE: doesn't kill a0 */
-	stq	v0, U_PCB_CONTEXT+(8 * 8)(a1)	/* store ps, for ipl */
-
-	mov	a0, s0				/* save old curproc */
-	mov	a1, s1				/* save old U-area */
- 
-cpu_switch_queuescan:
-	br	pv, 1f
-1:	LDGP(pv)
-	ldl	t0, whichqs		/* look for non-empty queue */
-	beq	t0, idle			/* and if none, go idle */
-	mov	t0, t3				/* t3 = saved whichqs */
-	mov	zero, t2			/* t2 = lowest bit set */
-	blbs	t0, 3f				/* if low bit set, done! */
-
-2:	srl	t0, 1, t0			/* try next bit */
-	addq	t2, 1, t2
-	blbc	t0, 2b				/* if clear, try again */
-
-3:	/*
-	 * Remove process from queue
-	 */
-	lda	t1, qs				/* get queues */
-	sll	t2, 4, t0			/* queue head is 16 bytes */
-	addq	t1, t0, t0			/* t0 = qp = &qs[firstbit] */
-
-	ldq	t4, PH_LINK(t0)			/* t4 = p = highest pri proc */
-	bne	t4, 4f				/* make sure p != NULL */
-	PANIC("cpu_switch",Lcpu_switch_pmsg)	/* nothing in queue! */
-
-4:
-	ldq	t5, P_FORW(t4)			/* t5 = p->p_forw */
-	stq	t5, PH_LINK(t0)			/* qp->ph_link = p->p_forw */
-	stq	t0, P_BACK(t5)			/* p->p_forw->p_back = qp */
-	stq	zero, P_BACK(t4)		/* firewall: p->p_back = NULL */
-	cmpeq	t0, t5, t0			/* see if queue is empty */
-	beq	t0, 5f				/* nope, it's not! */
-
-	ldiq	t0, 1				/* compute bit in whichqs */
-	sll	t0, t2, t0
-	xor	t3, t0, t3			/* clear bit in whichqs */
-	stl	t3, whichqs
 
-5:
-	mov	t4, s2				/* save new proc */
-	ldq	s3, P_MD_PCBPADDR(s2)		/* save new pcbpaddr */
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
 	/*
-	 * Done mucking with the run queues, release the
-	 * scheduler lock, but keep interrupts out.
+	 * Don't bother saving the old context if oldproc is NULL.
 	 */
-	CALL(sched_unlock_idle)
-#endif
+	beq	a0, 1f
 
 	/*
-	 * Check to see if we're switching to ourself.  If we are,
-	 * don't bother loading the new context.
-	 *
-	 * Note that even if we re-enter cpu_switch() from idle(),
-	 * s0 will still contain the old curproc value because any
-	 * users of that register between then and now must have
-	 * saved it.  Also note that switch_exit() ensures that
-	 * s0 is clear before jumping here to find a new process.
+	 * do an inline savectx(), to save old context
 	 */
-	cmpeq	s0, s2, t0			/* oldproc == newproc? */
-	bne	t0, 7f				/* Yes!  Skip! */
+	call_pal PAL_OSF1_rdps			/* NOTE: doesn't kill a0 */
+	ldq	t0, P_ADDR(a0)
+	/* NOTE: ksp is stored by the swpctx */
+	stq	s0, U_PCB_CONTEXT+(0 * 8)(t0)	/* store s0 - s6 */
+	stq	s1, U_PCB_CONTEXT+(1 * 8)(t0)
+	stq	s2, U_PCB_CONTEXT+(2 * 8)(t0)
+	stq	s3, U_PCB_CONTEXT+(3 * 8)(t0)
+	stq	s4, U_PCB_CONTEXT+(4 * 8)(t0)
+	stq	s5, U_PCB_CONTEXT+(5 * 8)(t0)
+	stq	s6, U_PCB_CONTEXT+(6 * 8)(t0)
+	stq	ra, U_PCB_CONTEXT+(7 * 8)(t0)	/* store ra */
+	stq	v0, U_PCB_CONTEXT+(8 * 8)(t0)	/* store ps, for ipl */
+
+1:
+	mov	a0, s0				/* save old proc */
+	mov	a1, s2				/* save new proc */
+	ldq	s3, P_MD_PCBPADDR(s2)		/* save new pcbpaddr */
 
 	/*
 	 * Deactivate the old address space before activating the
@@ -842,18 +757,18 @@
 	 * do this after we activate, then we might end up
 	 * incorrectly marking the pmap inactive!
 	 *
-	 * We don't deactivate if we came here from switch_exit
+	 * We don't deactivate if we came here from sched_exit
 	 * (old pmap no longer exists; vmspace has been freed).
 	 * oldproc will be NULL in this case.  We have actually
 	 * taken care of calling pmap_deactivate() in cpu_exit(),
 	 * before the vmspace went away.
 	 */
-	beq	s0, 6f
+	beq	s0, 2f
 
 	mov	s0, a0				/* pmap_deactivate(oldproc) */
 	CALL(pmap_deactivate)
 
-6:	/*
+2:	/*
 	 * Activate the new process's address space and perform
 	 * the actual context swap.
 	 */
@@ -864,7 +779,7 @@
 	mov	s3, a0				/* swap the context */
 	SWITCH_CONTEXT
 
-7:	/*
+	/*
 	 * Now that the switch is done, update curproc and other
 	 * globals.  We must do this even if switching to ourselves
 	 * because we might have re-entered cpu_switch() from idle(),
@@ -911,7 +826,7 @@
 
 	ldiq	v0, 1				/* possible ret to savectx() */
 	RET
-	END(cpu_switch)
+	END(cpu_switchto)
 
 #ifndef SMALL_KERNEL
 	/*
@@ -926,6 +841,18 @@
 EXPORT(__bwx_switch3)
 #endif
 
+LEAF(cpu_idle_enter, 0)
+	RET
+	END(cpu_idle_enter)
+
+LEAF(cpu_idle_cycle, 0)
+	RET
+	END(cpu_idle_cycle)
+
+LEAF(cpu_idle_leave, 0)
+	RET
+	END(cpu_idle_leave)
+
 /*
  * switch_trampoline()
  *
@@ -944,46 +871,6 @@
 	mov	s2, a0
 	jmp	zero, (pv)
 	END(switch_trampoline)
-
-/*
- * switch_exit(struct proc *p)
- * Make a the named process exit.  Partially switch to our idle thread
- * (we don't update curproc or restore registers), and jump into the middle
- * of cpu_switch to switch into a few process.  The process reaper will
- * free the dead process's VM resources.  MUST BE CALLED AT SPLHIGH.
- */
-LEAF(switch_exit, 1)
-	LDGP(pv)
-
-	/* save the exiting proc pointer */
-	mov	a0, s2
-
-	/* Switch to our idle stack. */
-	GET_IDLE_PCB(a0)			/* clobbers v0, t0, t8-t11 */
-	SWITCH_CONTEXT
-
-	/*
-	 * Now running as idle thread, except for the value of 'curproc' and
-	 * the saved regs.
-	 */
-
-	/* Schedule the vmspace and stack to be freed. */
-	mov	s2, a0
-	CALL(exit2)
-
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	CALL(sched_lock_idle)			/* acquire sched_lock */
-#endif
-
-	/*
-	 * Now jump back into the middle of cpu_switch().  Note that
-	 * we must clear s0 to guarantee that the check for switching
-	 * to ourselves in cpu_switch() will fail.  This is safe since
-	 * s0 will be restored when a new process is resumed.
-	 */
-	mov	zero, s0
-	jmp	zero, cpu_switch_queuescan
-	END(switch_exit)
 
 /**************************************************************************/
 
Index: arch/alpha/alpha/machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/alpha/alpha/machdep.c,v
retrieving revision 1.112
diff -u -r1.112 machdep.c
--- arch/alpha/alpha/machdep.c	15 Sep 2007 10:10:37 -0000	1.112
+++ arch/alpha/alpha/machdep.c	25 Sep 2007 09:53:37 -0000
@@ -1874,66 +1874,6 @@
 }
 
 /*
- * The following primitives manipulate the run queues.  _whichqs tells which
- * of the 32 queues _qs have processes in them.  Setrunqueue puts processes
- * into queues, Remrunqueue removes them from queues.  The running process is
- * on no queue, other processes are on a queue related to p->p_priority,
- * divided by 4 actually to shrink the 0-127 range of priorities into the 32
- * available queues.
- */
-/*
- * setrunqueue(p)
- *	proc *p;
- *
- * Call should be made at splclock(), and p->p_stat should be SRUN.
- */
-
-/* XXXART - grmble */
-#define sched_qs qs
-#define sched_whichqs whichqs
-
-void
-setrunqueue(p)
-	struct proc *p;
-{
-	int bit;
-
-	/* firewall: p->p_back must be NULL */
-	if (p->p_back != NULL)
-		panic("setrunqueue");
-
-	bit = p->p_priority >> 2;
-	sched_whichqs |= (1 << bit);
-	p->p_forw = (struct proc *)&sched_qs[bit];
-	p->p_back = sched_qs[bit].ph_rlink;
-	p->p_back->p_forw = p;
-	sched_qs[bit].ph_rlink = p;
-}
-
-/*
- * remrunqueue(p)
- *
- * Call should be made at splclock().
- */
-void
-remrunqueue(p)
-	struct proc *p;
-{
-	int bit;
-
-	bit = p->p_priority >> 2;
-	if ((sched_whichqs & (1 << bit)) == 0)
-		panic("remrunqueue");
-
-	p->p_back->p_forw = p->p_forw;
-	p->p_forw->p_back = p->p_back;
-	p->p_back = NULL;	/* for firewall checking. */
-
-	if ((struct proc *)&sched_qs[bit] == sched_qs[bit].ph_link)
-		sched_whichqs &= ~(1 << bit);
-}
-
-/*
  * Wait "n" microseconds.
  */
 void
Index: arch/alpha/alpha/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/alpha/alpha/vm_machdep.c,v
retrieving revision 1.34
diff -u -r1.34 vm_machdep.c
--- arch/alpha/alpha/vm_machdep.c	3 Sep 2007 01:24:22 -0000	1.34
+++ arch/alpha/alpha/vm_machdep.c	25 Sep 2007 09:53:38 -0000
@@ -114,9 +114,7 @@
 	 * vmspace's context until the switch to proc0 in switch_exit().
 	 */
 	pmap_deactivate(p);
-
-	(void) splhigh();
-	switch_exit(p);
+	sched_exit(p);
 	/* NOTREACHED */
 }
 
Index: arch/amd64/amd64/cpu.c
===================================================================
RCS file: /cvs/src/sys/arch/amd64/amd64/cpu.c,v
retrieving revision 1.14
diff -u -r1.14 cpu.c
--- arch/amd64/amd64/cpu.c	17 Sep 2007 15:34:38 -0000	1.14
+++ arch/amd64/amd64/cpu.c	25 Sep 2007 09:53:38 -0000
@@ -345,6 +345,7 @@
 #if defined(MULTIPROCESSOR)
 		cpu_intr_init(ci);
 		gdt_alloc_cpu(ci);
+		sched_init_cpu(ci);
 		cpu_start_secondary(ci);
 		ncpus++;
 		if (ci->ci_flags & CPUF_PRESENT) {
@@ -540,6 +541,9 @@
 
 	microuptime(&ci->ci_schedstate.spc_runtime);
 	splx(s);
+
+	SCHED_LOCK(s);
+	cpu_switchto(NULL, sched_chooseproc());
 }
 
 #if defined(DDB)
Index: arch/amd64/amd64/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/amd64/amd64/genassym.cf,v
retrieving revision 1.14
diff -u -r1.14 genassym.cf
--- arch/amd64/amd64/genassym.cf	1 Jun 2007 21:01:51 -0000	1.14
+++ arch/amd64/amd64/genassym.cf	25 Sep 2007 09:53:38 -0000
@@ -33,8 +33,6 @@
 
 struct	proc
 member	p_addr
-member	p_back
-member	p_forw
 member	p_priority
 member	p_stat
 member	p_wchan
Index: arch/amd64/amd64/locore.S
===================================================================
RCS file: /cvs/src/sys/arch/amd64/amd64/locore.S,v
retrieving revision 1.23
diff -u -r1.23 locore.S
--- arch/amd64/amd64/locore.S	12 Sep 2007 18:18:27 -0000	1.23
+++ arch/amd64/amd64/locore.S	25 Sep 2007 09:53:39 -0000
@@ -723,13 +723,8 @@
  * actually to shrink the 0-127 range of priorities into the 32 available
  * queues.
  */
-	.globl	_C_LABEL(whichqs),_C_LABEL(qs)
 	.globl	_C_LABEL(uvmexp),_C_LABEL(panic)
 
-#if NAPM > 0
-	.globl _C_LABEL(apm_cpu_idle),_C_LABEL(apm_cpu_busy)
-#endif
-
 #ifdef DIAGNOSTIC
 NENTRY(switch_error1)
 	movabsq	$1f,%rdi
@@ -749,12 +744,10 @@
 #endif /* DIAGNOSTIC */
 
 /*
- * int cpu_switch(struct proc *)
- * Find a runnable process and switch to it.  Wait if necessary.  If the new
- * proc is the same as the old one, we short-circuit the context save and
- * restore.
+ * int cpu_switchto(struct proc *old, struct proc *new)
+ * Switch from "old" proc to "new".
  */
-ENTRY(cpu_switch)
+ENTRY(cpu_switchto)
 	pushq	%rbx
 	pushq	%rbp
 	pushq	%r12
@@ -762,163 +755,12 @@
 	pushq	%r14
 	pushq	%r15
 
-	movq	%rdi,%r13
-
-	/*
-	 * Clear curproc so that we don't accumulate system time while idle.
-	 * This also insures that schedcpu() will move the old proc to
-	 * the correct queue if it happens to get called from the spllower()
-	 * below and changes the priority.  (See corresponding comment in
-	 * userret()).
-	 */
-	movq	$0,CPUVAR(CURPROC)
-
-
-	/*
-	 * First phase: find new proc.
-	 *
-	 * Registers:
-	 *   %rax - queue head, scratch, then zero
-	 *   %r8 - queue number
-	 *   %ecx - cached value of whichqs
-	 *   %rdx - next process in queue
-	 *   %r13 - old proc
-	 *   %r12 - new proc
-	 */
-
-	/* Look for new proc. */
-	cli				# splhigh doesn't do a cli
-	movl	_C_LABEL(whichqs)(%rip),%ecx
-	bsfl	%ecx,%r8d		# find a full q
-	jnz	switch_dequeue
-
-	/*
-	 * idling: save old context
-	 *
-	 * Registers:
-	 * %rax, %rcx - scratch
-	 * %r13 - old proc, then old pcb
-	 * %r12 - idle pcb
-	 */
-
-	/* old proc still in %rdi */
-	call	_C_LABEL(pmap_deactivate)
-
-	movq	P_ADDR(%r13),%r13
-
-	/* Save stack pointers */
-
-	movq	%rsp,PCB_RSP(%r13)
-	movq	%rbp,PCB_RBP(%r13)
-
-	/* Find idle PCB for this CPU */
-#ifndef MULTIPROCESSOR
-	leaq	_C_LABEL(proc0)(%rip),%rcx
-	movq	P_ADDR(%rcx),%r12
-	movl	P_MD_TSS_SEL(%rcx),%edx
-#else
-	movq	CPUVAR(IDLE_PCB),%r12
-	movl	CPUVAR(IDLE_TSS_SEL),%edx
-#endif
-	movq	$0,CPUVAR(CURPROC)
-
-	/* Restore the idle context (avoid interrupts) */
-	cli
-
-	/* Restore stack pointers. */
-	movq	PCB_RSP(%r12),%rsp
-	movq	PCB_RBP(%r12),%rbp
-
-	/* Switch address space. */
-	movq	PCB_CR3(%r12),%rcx
-	movq	%rcx,%cr3
-
-#ifdef MULTIPROCESSOR
-	movq	CPUVAR(GDT),%rax
-#else
-	movq	_C_LABEL(gdtstore)(%rip),%rax
-#endif
-
-	/* Switch TSS. Reset "task busy" flag before */
-	andl	$~0x0200,4(%rax,%rdx, 1)
-	ltr	%dx
-
-	/* Restore cr0 (including FPU state). */
-	movl	PCB_CR0(%r12),%ecx
-	movq	%rcx,%cr0
-
-	SET_CURPCB(%r12)
-
-	xorq	%r13,%r13
-	sti
-idle_unlock:
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)       
-	call	_C_LABEL(sched_unlock_idle)
-#endif
-	/* Interrupts are okay again. */
-	movl	$IPL_NONE,%edi
-	call	_C_LABEL(Xspllower)
-	jmp	idle_start
-idle_zero:
-	sti
-	call	_C_LABEL(uvm_pageidlezero)
-	cli
-	cmpl	$0,_C_LABEL(whichqs)(%rip)
-	jnz	idle_exit
-idle_loop:
-#if NPCTR > 0
-	incq	_C_LABEL(pctr_idlcnt)
-#endif
-	/* Try to zero some pages. */
-	movl	_C_LABEL(uvm)+UVM_PAGE_IDLE_ZERO(%rip),%ecx
-	testl	%ecx,%ecx
-	jnz	idle_zero
-	sti
-	hlt
-NENTRY(mpidle)
-idle_start:
-	cli
-	cmpl	$0,_C_LABEL(whichqs)(%rip)
-	jz	idle_loop
-idle_exit:
-	movl	$IPL_HIGH,CPUVAR(ILEVEL)
-	sti
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)       
-	call	_C_LABEL(sched_lock_idle)
-#endif
-switch_search:
-	movl	_C_LABEL(whichqs)(%rip),%ecx
-	bsfl	%ecx,%r8d
-	jz	idle_unlock
-
-switch_dequeue:
-
-	sti
-	movq	%r8,%r9
-
-	shlq	$4, %r9
-	leaq	_C_LABEL(qs)(%rip),%rax
-	addq	%r9,%rax
-	/* movq	(%rax),%rax */
-
-	movq	P_FORW(%rax),%r12	# unlink from front of process q
-#ifdef	DIAGNOSTIC
-	cmpq	%r12,%rax		# linked to self (i.e. nothing queued)?
-	je	_C_LABEL(switch_error1)	# not possible
-#endif /* DIAGNOSTIC */
-	movq	P_FORW(%r12),%rdx
-	movq	%rdx,P_FORW(%rax)
-	movq	%rax,P_BACK(%rdx)
-
-	cmpq	%rdx,%rax		# q empty?
-	jne	3f
-
-	btrl	%r8d,%ecx		# yes, clear to indicate empty
-	movl	%ecx,_C_LABEL(whichqs)(%rip) # update q status
+	movq	%rdi, %r13
+	movq	%rsi, %r12
 
-3:	/* We just did it. */
 	xorq	%rax,%rax
 	movl	%eax,CPUVAR(RESCHED)
+
 switch_resume:
 #ifdef DIAGNOSTIC
 	cmpq	%rax,P_WCHAN(%r12)
@@ -927,24 +769,16 @@
 	jne	_C_LABEL(switch_error3)
 #endif
 
-	/* Isolate proc.  XXX Is this necessary? */
-	movq	%rax,P_BACK(%r12)
-
 	/* Record new proc. */
 	movb	$SONPROC,P_STAT(%r12)	# p->p_stat = SONPROC
 	SET_CURPROC(%r12,%rcx)
 
-	/* Skip context switch if same proc. */
-	xorl	%ebx,%ebx
-	cmpq	%r12,%r13
-	je	switch_return
-
 	/* If old proc exited, don't bother. */
 	testq	%r13,%r13
 	jz	switch_exited
 
 	/*
-	 * Second phase: save old context.
+	 * Save old context.
 	 *
 	 * Registers:
 	 *   %rax, %rcx - scratch
@@ -963,7 +797,7 @@
 
 switch_exited:
 	/*
-	 * Third phase: restore saved context.
+	 * Restore saved context.
 	 *
 	 * Registers:
 	 *   %rax, %rcx, %rdx - scratch
@@ -1020,15 +854,13 @@
 	sti
 
 switch_return:
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)     
-	call	_C_LABEL(sched_unlock_idle)
-#endif
 
+#if 0
+	/* Violation of lock ordering, since we're holding the sched_lock */
 	movl	$IPL_NONE,%edi
 	call	_C_LABEL(Xspllower)
 	movl	$IPL_HIGH,CPUVAR(ILEVEL)
-
-	movl	%ebx,%eax
+#endif
 
 	popq	%r15
 	popq	%r14
@@ -1038,87 +870,16 @@
 	popq	%rbx
 	ret
 
-ENTRY(cpu_switchto)
-	pushq	%rbx
-	pushq	%rbp
-	pushq	%r12
-	pushq	%r13
-	pushq	%r14
-	pushq	%r15
-
-	movq	%rdi,%r13
-	movq	%rsi,%r12
-
-	movq	$0,CPUVAR(CURPROC)
-
-	xorq	%rax,%rax
-	jmp	switch_resume
-
-
-/*
- * void switch_exit(struct proc *l, void (*exit)(struct proc *));
- * Switch to proc0's saved context and deallocate the address space and kernel
- * stack for p.  Then jump into cpu_switch(), as if we were in proc0 all along.
- */
-	.globl	_C_LABEL(proc0)
-ENTRY(switch_exit)
-#ifdef MULTIPROCESSOR
-	movq	CPUVAR(IDLE_PCB),%r8
-	movl	CPUVAR(IDLE_TSS_SEL),%edx
-#else
-	leaq	_C_LABEL(proc0)(%rip),%r9
-	movq	P_ADDR(%r9),%r8
-	movl	P_MD_TSS_SEL(%r9),%edx
-#endif
-
-	/* In case we fault... */
-	movq	$0,CPUVAR(CURPROC)
-
-	cli
-
-	/* Restore stack pointers. */
-	movq	PCB_RSP(%r8),%rsp
-	movq	PCB_RBP(%r8),%rbp
-
-	/* Load TSS info. */
-#ifdef MULTIPROCESSOR
-	movq	CPUVAR(GDT),%rax
-#else
-	movq	_C_LABEL(gdtstore)(%rip),%rax
-#endif
-
-	/* Switch address space. */
-	movq	PCB_CR3(%r8),%rcx
-	movq	%rcx,%cr3
-
-	/* Switch TSS. */
-	andl	$~0x0200,4-SEL_KPL(%rax,%rdx,1)
-	ltr	%dx
-
-	/* We're always in the kernel, so we don't need the LDT. */
-
-	/* Restore cr0 (including FPU state). */
-	movl	PCB_CR0(%r8),%ecx
-	movq	%rcx,%cr0
-
-	/* Record new pcb. */
-	SET_CURPCB(%r8)
-
-	/* Interrupts are okay again. */
-	sti
+ENTRY(cpu_idle_enter)
+	ret
 
-	/*
-	 * Schedule the dead process's vmspace and stack to be freed.
-	 * {lpw_}exit2(l). Function still in %rsi (2nd arg), proc in
-	 * %rdi (first arg).
-	 */
+ENTRY(cpu_idle_cycle)
+	hlt
+	ret
 
-	call	*%rsi
+ENTRY(cpu_idle_leave)
+	ret
 
-	/* Jump into cpu_switch() with the right state. */
-	xorq	%r13,%r13
-	movq	%r13, CPUVAR(CURPROC)
-	jmp	switch_search
 
 /*
  * savectx(struct pcb *pcb);
Index: arch/amd64/amd64/mptramp.S
===================================================================
RCS file: /cvs/src/sys/arch/amd64/amd64/mptramp.S,v
retrieving revision 1.3
diff -u -r1.3 mptramp.S
--- arch/amd64/amd64/mptramp.S	26 Jul 2005 08:38:29 -0000	1.3
+++ arch/amd64/amd64/mptramp.S	25 Sep 2007 09:53:39 -0000
@@ -235,5 +235,4 @@
 	movl    PCB_CR0(%rsi),%eax
 	movq    %rax,%cr0
 	call	_C_LABEL(cpu_hatch)
-	xorq	%r13,%r13
-	jmp	_C_LABEL(mpidle)
+	/* NOTREACHED */
Index: arch/amd64/amd64/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/amd64/amd64/vm_machdep.c,v
retrieving revision 1.10
diff -u -r1.10 vm_machdep.c
--- arch/amd64/amd64/vm_machdep.c	27 May 2007 20:59:25 -0000	1.10
+++ arch/amd64/amd64/vm_machdep.c	25 Sep 2007 09:53:39 -0000
@@ -169,12 +169,8 @@
 	if (p->p_md.md_flags & MDP_USEDMTRR)
 		mtrr_clean(p);
 
-	/*
-	 * No need to do user LDT cleanup here; it's handled in
-	 * pmap_destroy().
-	 */
-
-	switch_exit(p, exit2);
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/amd64/conf/files.amd64
===================================================================
RCS file: /cvs/src/sys/arch/amd64/conf/files.amd64,v
retrieving revision 1.34
diff -u -r1.34 files.amd64
--- arch/amd64/conf/files.amd64	12 Sep 2007 18:18:27 -0000	1.34
+++ arch/amd64/conf/files.amd64	25 Sep 2007 09:53:39 -0000
@@ -18,7 +18,6 @@
 file	arch/amd64/amd64/trap.c
 file	arch/amd64/amd64/vm_machdep.c
 file	arch/amd64/amd64/fpu.c
-file	arch/amd64/amd64/Locore.c
 file	arch/amd64/amd64/softintr.c
 file	arch/amd64/amd64/i8259.c
 file	arch/amd64/amd64/cacheinfo.c
Index: arch/aviion/aviion/locore.S
===================================================================
RCS file: /cvs/src/sys/arch/aviion/aviion/locore.S,v
retrieving revision 1.3
diff -u -r1.3 locore.S
--- arch/aviion/aviion/locore.S	20 May 2006 22:40:43 -0000	1.3
+++ arch/aviion/aviion/locore.S	25 Sep 2007 09:53:39 -0000
@@ -343,14 +343,6 @@
 	bsr.n	_C_LABEL(secondary_main)
 	 addu	r31, r3, USIZE			/* switch to idle stack */
 
-	/*
-	 * At this point, the CPU has been correctly initialized and has
-	 * identified itself on the console.
-	 * All it needs now is to jump to the idle loop and wait for work to
-	 * be offered.
-	 */
-	br	_ASM_LABEL(cpu_switch_idle)
-
 #endif	/* MULTIPROCESSOR */
 
 /* 
Index: arch/aviion/aviion/machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/aviion/aviion/machdep.c,v
retrieving revision 1.10
diff -u -r1.10 machdep.c
--- arch/aviion/aviion/machdep.c	6 Jun 2007 17:15:11 -0000	1.10
+++ arch/aviion/aviion/machdep.c	25 Sep 2007 09:53:40 -0000
@@ -225,8 +225,6 @@
 {
 	caddr_t v;
 	int sz, i;
-	vsize_t size;
-	int base, residual;
 	vaddr_t minaddr, maxaddr;
 
 	/*
@@ -605,19 +603,18 @@
 secondary_main()
 {
 	struct cpu_info *ci = curcpu();
+	int s;
 
 	cpu_configuration_print(0);
+	sched_init_cpu(ci);
 	ncpus++;
 	__cpu_simple_unlock(&cpu_mutex);
 
 	microuptime(&ci->ci_schedstate.spc_runtime);
 	ci->ci_curproc = NULL;
 
-	/*
-	 * Upon return, the secondary cpu bootstrap code in locore will
-	 * enter the idle loop, waiting for some food to process on this
-	 * processor.
-	 */
+	SCHED_LOCK(s);
+	cpu_switchto(NULL, sched_chooseproc());
 }
 
 #endif	/* MULTIPROCESSOR */
Index: arch/hp300/hp300/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/hp300/hp300/locore.s,v
retrieving revision 1.60
diff -u -r1.60 locore.s
--- arch/hp300/hp300/locore.s	15 May 2007 13:46:22 -0000	1.60
+++ arch/hp300/hp300/locore.s	25 Sep 2007 09:53:41 -0000
@@ -1345,51 +1345,18 @@
  */
 #include <m68k/m68k/support.s>
 
-/*
- * Use common m68k process manipulation routines.
- */
-#include <m68k/m68k/proc_subr.s>
-
 	.data
 GLOBAL(curpcb)
 	.long	0
 
 ASBSS(nullpcb,SIZEOF_PCB)
 
-/*
- * At exit of a process, do a switch for the last time.
- * Switch to a safe stack and PCB, and deallocate the process's resources.
- */
-ENTRY(switch_exit)
-	movl	sp@(4),a0
-	/* save state into garbage pcb */
-	movl	#_ASM_LABEL(nullpcb),_C_LABEL(curpcb)
-	lea	_ASM_LABEL(tmpstk),sp	| goto a tmp stack
-
-        /* Schedule the vmspace and stack to be freed. */
-	movl    a0,sp@-                 | exit2(p)
-	jbsr    _C_LABEL(exit2)
-	lea     sp@(4),sp               | pop args
-
-	jra	_C_LABEL(cpu_switch)
-
-/*
- * When no processes are on the runq, Swtch branches to Idle
- * to wait for something to come ready.
- */
-ASENTRY_NOPROFILE(Idle)
+ENTRY_NOPROFILE(cpu_idle_cycle)
 	stop	#PSL_LOWIPL
-	movw	#PSL_HIGHIPL,sr
-	movl	_C_LABEL(whichqs),d0
-	jeq	_ASM_LABEL(Idle)
-	jra	Lsw1
-
-Lbadsw:
-	PANIC("switch")
-	/*NOTREACHED*/
+	rts
 
 /*
- * cpu_switch()
+ * cpu_switchto(struct proc *oldproc, struct proc *newproc)
  *
  * NOTE: On the mc68851 (318/319/330) we attempt to avoid flushing the
  * entire ATC.  The effort involved in selective flushing may not be
@@ -1399,55 +1366,15 @@
  * user's PTEs have been changed (formerly denoted by the SPTECHG p_flag
  * bit).  For now, we just always flush the full ATC.
  */
-ENTRY(cpu_switch)
-	movl	_C_LABEL(curpcb),a0	| current pcb
-	movw	sr,a0@(PCB_PS)		| save sr before changing ipl
-#ifdef notyet
-	movl	CURPROC,sp@-		| remember last proc running
-#endif
-	clrl	CURPROC
+ENTRY(cpu_switchto)
+	movl	sp@(4), d0		| oldproc
+	beq	Lswnofpsave		| is NULL, don't save anything
 
 	/*
-	 * Find the highest-priority queue that isn't empty,
-	 * then take the first proc from that queue.
-	 */
-	movw	#PSL_HIGHIPL,sr		| lock out interrupts
-	movl	_C_LABEL(whichqs),d0
-	jeq	_ASM_LABEL(Idle)
-Lsw1:
-	movl	d0,d1
-	negl	d0
-	andl	d1,d0
-	bfffo	d0{#0:#32},d1
-	eorib	#31,d1
-
-	movl	d1,d0
-	lslb	#3,d1			| convert queue number to index
-	addl	#_C_LABEL(qs),d1	| locate queue (q)
-	movl	d1,a1
-	movl	a1@(P_FORW),a0		| p = q->p_forw
-	cmpal	d1,a0			| anyone on queue?
-	jeq	Lbadsw			| no, panic
-	movl	a0@(P_FORW),a1@(P_FORW)	| q->p_forw = p->p_forw
-	movl	a0@(P_FORW),a1		| n = p->p_forw
-	movl	d1,a1@(P_BACK)		| n->p_back = q
-	cmpal	d1,a1			| anyone left on queue?
-	jne	Lsw2			| yes, skip
-	movl	_C_LABEL(whichqs),d1
-	bclr	d0,d1			| no, clear bit
-	movl	d1,_C_LABEL(whichqs)
-Lsw2:
-	movl	a0,CURPROC
-	clrl	_C_LABEL(want_resched)
-#ifdef notyet
-	movl	sp@+,a1
-	cmpl	a0,a1			| switching to same proc?
-	jeq	Lswdone			| yes, skip save and restore
-#endif
-	/*
 	 * Save state of previous process in its pcb.
 	 */
 	movl	_C_LABEL(curpcb),a1
+	movw	sr, a1@(PCB_PS)		| save sr before switching context
 	moveml	#0xFCFC,a1@(PCB_REGS)	| save non-scratch registers
 	movl	usp,a2			| grab USP (a2 has been saved)
 	movl	a2,a1@(PCB_USP)		| and save it
@@ -1460,16 +1387,12 @@
 	jeq	Lswnofpsave		| yes, all done
 	fmovem	fp0-fp7,a2@(FPF_REGS)	| save FP general registers
 	fmovem	fpcr/fpsr/fpi,a2@(FPF_FPCR)	| save FP control registers
+
 Lswnofpsave:
+	movl	sp@(8), a0		| newproc
 
-#ifdef DIAGNOSTIC
-	tstl	a0@(P_WCHAN)
-	jne	Lbadsw
-	cmpb	#SRUN,a0@(P_STAT)
-	jne	Lbadsw
-#endif
+	movl	a0, CURPROC
 	movb	#SONPROC,a0@(P_STAT)
-	clrl	a0@(P_BACK)		| clear back link
 	movl	a0@(P_ADDR),a1		| get p_addr
 	movl	a1,_C_LABEL(curpcb)
 
Index: arch/hp300/hp300/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/hp300/hp300/vm_machdep.c,v
retrieving revision 1.43
diff -u -r1.43 vm_machdep.c
--- arch/hp300/hp300/vm_machdep.c	27 May 2007 20:59:25 -0000	1.43
+++ arch/hp300/hp300/vm_machdep.c	25 Sep 2007 09:53:41 -0000
@@ -133,10 +133,10 @@
 cpu_exit(p)
 	struct proc *p;
 {
+	(void)splhigh();
 
-	(void) splhigh();
-	switch_exit(p);
-	/* NOTREACHED */
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/hppa/hppa/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/hppa/hppa/genassym.cf,v
retrieving revision 1.30
diff -u -r1.30 genassym.cf
--- arch/hppa/hppa/genassym.cf	14 May 2007 19:54:21 -0000	1.30
+++ arch/hppa/hppa/genassym.cf	25 Sep 2007 09:53:41 -0000
@@ -130,8 +130,6 @@
 
 # proc fields and values
 struct	proc
-member	p_forw
-member	p_back
 member	p_addr
 member	p_priority
 member	p_stat
